#!/usr/local/bin/awk -f

# "Manual" is if you want the pop-up Firefox and prompt for choice.

# Demon to pass data back and forth between Windows host and Linux guest OS under VirtualBox
# See also demon-win.awk for the version running on the Windows host.
# Purposes is to run AWB on windows, and unix scripts on Linux. 

# CAUTION: NOT CONVERTED TO PROJECT[] SYSTEM

@include "init.awk"
@include "library.awk"

BEGIN {

 # Begin configuration

 # system programs
  rm = "/bin/rm"
  mv = "/bin/mv"
  cp = "/bin/cp"
  sleepbin = "/bin/sleep"

 # paths
  fname = Ramdisk "name.txt"            # File containing name passed *from* AWB to unix script
  farticle = Ramdisk "article.txt"      # File containing article passed *to* AWB from unix script
  fabort = Ramdisk "abort.txt"          # File flagging abort

 # End configuration

  wicsh = readfile(Home "wi.csh")
  if( match(wicsh, /set internetarchive10 = 0/) ) {
    print "Error: wi.csh not set to internetarchive10"
    exit
  }

  main()

}

function main(    name,tempid,article) {

  removefile(farticle)              # Clear out old files
  removefile(fabort)              

  prnt("\ndemon-lin.awk: Waiting for " fname " ...")

  while(1) {

    sleep(2)
    Z++
    if(Z > 500) exit   # time-out. 2500 = about 90 minutes w/ 2sec sleep

    if( exists(fname) ) {

      Z = 0             # reset time-out

      name = strip( readfile(fname) )
      prnt("demon-lin.awk: New job request: " name )
      removefile(fname)
      removefile(farticle)

      if(length(name) > 0) {           

        if( ! nameisinfile(name, "ia9out-index") ) {
          abort("demon-lin.awk: Error name not found in ia9out-index. " name)
        }
        else {
          command = Home "wi.csh \"" name "\""
          system(command)
          if(exists(Homeshared "article.txt") ) {
            command = cp " " Homeshared "article.txt " farticle
            prnt("demon-lin.awk: Status successful. Copied article.txt to shared directory. " name) 
            sys2var(command)
          }
          else {
            abort("demon-lin.awk: Warning article.txt missing. " name)
          }
        }
      }
      else {
        abort("demon-lin.awk: error retrieving name")
      }  
      prnt("\ndemon-lin.awk: Waiting for " fname " ...")
    }
  }
}

#
# Return 1 if name is in file 
#
function nameisinfile(name, filen,    filepath, s, a, re) {
  filepath = Home filen
  if(! exists(filepath) ) {
    abort("demon-lin.awk: Error unable to find " filepath ". " name )
    return 0
  }
  re = "^" regesc(strip(name)) "$"
  while ((getline s < filepath ) > 0) {
    split(s, a, "|")
    if(strip(a[1]) ~ re)
      return 1
  }
  close(filepath)
  return 0
}

#
# Abort 
#
function abort(msg,  filen) {
  if( length(msg) > 0 ) 
    prnt(msg)
  printf "0" > fabort
  close(fabort)
}

#
# Print and log messages
#
function prnt(msg) {
  if( length(msg) > 0 ) {
    print(msg)
    print(strftime("%Y%m%d %H:%M:%S") " " msg) >> Home "demon-lin.log"
    close(Home "demon-lin.log")
  }
}

function removefile(str) {
      if( exists(str) )
        sys2var(rm " -- " str)
      if( exists(str) ) {
        abort("demon-lin.awk: Error unable to delete " str ", aborting.")
        exit
      }
      system("") # Flush buffer
}

#
# Sleep 
#
function sleep(seconds)
{
  sys2var(sleepbin " " seconds)
}


